#include <Servo.h>          //Servo motor library. This is standard library
#include <NewPing.h>        //Ultrasonic sensor function library. You must install this library

//our L298N control pins
const int LeftMotorForward = 7;
const int LeftMotorBackward = 8;
const int LeftMotorSpeed = 6;
const int RightMotorForward = 9;
const int RightMotorBackward = 10;
const int RightMotorSpeed = 11;
const int RightFrontSensor = 2;
const int RightBackSensor = 12;
const int BackSensor = 13;
#define Speed  110

//sensor pins
#define trig_pin 3 
#define echo_pin 4 

#define maximum_distance 200
boolean goesForward = false;
int distance = 100;
int RightFrontDistance = 0;
int RightBackDistance = 0;
int BackDistance = 0;

NewPing sonar(trig_pin, echo_pin, maximum_distance); //sensor function
Servo servo_motor; //our servo name

int comutator=A0;
int valoare_comutator=0;
unsigned long counter=0; //unsigned long permite valori maxime de 4,294,967,295 fata de unsigned int care permite max. 65,535
boolean start = true;


// senzorul se uita in dreapta
int lookRight(){  
  servo_motor.write(50);
  delay(500);
  int distance = readPing();
  delay(100);
  servo_motor.write(115);
  return distance;
}

// senzorul se uita in stanga
int lookLeft(){
  servo_motor.write(170);
  delay(500);
  int distance = readPing();
  delay(100);
  servo_motor.write(115);
  return distance;
  delay(100);
}

// senzorul citeste distanta
int readPing(){
  delay(70);
  int cm = sonar.ping_cm();
  if (cm==0){
    cm=250;
  }
  return cm;
}

// functie pentru oprire
void moveStop(){
  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(LeftMotorForward, LOW);
  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(RightMotorBackward, LOW);
  digitalWrite(LeftMotorBackward, LOW);
}

// functie pentru deplasare inainte
void moveForward(){

  if(!goesForward){

    goesForward=true;
    analogWrite(LeftMotorSpeed, Speed);
    digitalWrite(LeftMotorForward, HIGH);
    digitalWrite(RightMotorForward, HIGH);

    analogWrite(RightMotorSpeed, (Speed - 24));
    digitalWrite(LeftMotorBackward, LOW);
    digitalWrite(RightMotorBackward, LOW); 
  }
}

// functie pentru deplasare inainte parcare
void moveForward2(){

    analogWrite(LeftMotorSpeed, Speed);
    digitalWrite(LeftMotorForward, HIGH);
    digitalWrite(RightMotorForward, HIGH);

    analogWrite(RightMotorSpeed, (Speed - 24));
    digitalWrite(LeftMotorBackward, LOW);
    digitalWrite(RightMotorBackward, LOW); 
   
  }


// functie pentru deplasare inapoi
void moveBackward(){

  goesForward=false;
  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(LeftMotorBackward, HIGH);
  digitalWrite(RightMotorBackward, HIGH);

  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(RightMotorForward, LOW);
  
}

// functie pentru deplasare inapoi parcare
void moveBackward2(){
 
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(LeftMotorBackward, HIGH);
  analogWrite(LeftMotorSpeed, Speed);
  
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(RightMotorBackward, HIGH);
  analogWrite(RightMotorSpeed, (Speed - 24));
   
}

 // functie pentru intoarcere la dreapta
void turnRight(){
  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(LeftMotorForward, HIGH);
  digitalWrite(RightMotorBackward, HIGH);

  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorForward, LOW);
  
  delay(300);
  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(LeftMotorForward, HIGH);
  digitalWrite(RightMotorForward, HIGH);

  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorBackward, LOW);
 
}

 // functie pentru intoarcere la dreapta parcare
void turnRight2(){
  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(LeftMotorForward, HIGH);
  digitalWrite(RightMotorBackward, HIGH);

  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorForward, LOW);
  
}

 // functie pentru intoarcere la stanga
void turnLeft(){
  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(LeftMotorBackward, HIGH);
  digitalWrite(RightMotorForward, HIGH);

  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(RightMotorBackward, LOW);

  delay(300);

  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(LeftMotorForward, HIGH);
  digitalWrite(RightMotorForward, HIGH);

  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorBackward, LOW);
}

 // functie pentru intoarcere la stanga parcare
void turnLeft2(){
  analogWrite(LeftMotorSpeed, Speed);
  digitalWrite(LeftMotorBackward, HIGH);
  digitalWrite(RightMotorForward, HIGH);

  analogWrite(RightMotorSpeed, Speed);
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(RightMotorBackward, LOW);

}

 // functie pentru intoarcere cu spatele parcare
void turnLeftBack(){
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(LeftMotorBackward, HIGH);
  analogWrite(LeftMotorSpeed, Speed);
    
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(RightMotorBackward, LOW);
  analogWrite(RightMotorSpeed, Speed);

}

 // functie pentru intoarcere cu fata parcare
void turnLeftForward(){
  digitalWrite(LeftMotorForward, HIGH);
  digitalWrite(LeftMotorBackward, LOW);
  analogWrite(LeftMotorSpeed, Speed);
    
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(RightMotorBackward, LOW);
  analogWrite(RightMotorSpeed, Speed);

}



void setup(){
  Serial.begin(9600);
  pinMode(RightMotorForward, OUTPUT);
  pinMode(LeftMotorForward, OUTPUT);
  pinMode(LeftMotorBackward, OUTPUT);
  pinMode(RightMotorBackward, OUTPUT);
  pinMode(LeftMotorSpeed, OUTPUT);
  pinMode(RightMotorSpeed, OUTPUT);
  pinMode(RightFrontSensor, INPUT);
  pinMode(RightBackSensor, INPUT);
  pinMode(BackSensor, INPUT);
  pinMode(comutator, INPUT);
  valoare_comutator=analogRead(comutator)< 900 ? 0 : 1;
  
  servo_motor.attach(5); //our servo pin

  servo_motor.write(115);
  delay(2000);
  distance = readPing();
  delay(100);
  distance = readPing();
  delay(100);
  distance = readPing();
  delay(100);
  distance = readPing();
  delay(100);
}

void loop(){
if (valoare_comutator==1 && start==true){
{ 
  RightFrontDistance = digitalRead(RightFrontSensor);
  RightBackDistance = digitalRead(RightBackSensor);

  counter=0;//resetare contor, pentru a inregistra spatiu liber continuu, altfel insumeaza mai multe spatii separate
  moveForward2();
      
  while (RightFrontDistance==1 && RightBackDistance==1) //atata timp cat ambii senzori dreapta detecteaza spatiu de parcare
  {
    RightFrontDistance = digitalRead(RightFrontSensor);
    RightBackDistance = digitalRead(RightBackSensor);
    counter+=1;  //contorul inregistreaza timpul de la detectarea spatiului liber pana la terminarea lui, asta in functie si de viteza, valoarea de comparat se stabileste prin tatonare
  } 

//Serial.println(counter);

   RightFrontDistance = digitalRead(RightFrontSensor);
  
   if (counter >= (unsigned long)(50000) && RightFrontDistance==0 && start==true)//conversie in unsigned long, default era unsigned int care permite max. 65,535
   {
    
     moveStop();
     delay(1000);
     moveBackward2();

    
      while (RightFrontDistance==0) //cat timp senzorul  dreapta fata detecteaza obstacol, adica pana la detectarea din nou a spatiului liber
      {
        RightFrontDistance = digitalRead(RightFrontSensor);
      }

      moveStop();
      delay(1000);
      
      turnLeftBack();
      delay(500);

      do  
      {
        BackDistance = digitalRead(BackSensor);
        moveBackward2();
      }  while (BackDistance==1);//cat timp distanta spate este mare
    

      moveStop();
      delay(1000);
      turnLeftForward();
      delay(500);
      
      do 
      {
         distance = readPing();
         moveForward2();
      }  while (distance > 10);//cat timp distanta fata este mai mare de ... cm
     //  Serial.println(distance);
       moveStop();
       start=false;
    }
  }
}




else if (valoare_comutator==0)
{ 
  int distanceRight = 0;
  int distanceLeft = 0;
  delay(50);

  if (distance <= 20){
    moveStop();
    delay(300);
    moveBackward();
    delay(300);
    moveStop();
    delay(300);
    distanceRight = lookRight();
    delay(300);
    distanceLeft = lookLeft();
    delay(300);

    if (distance >= distanceLeft){
      turnRight();
      moveStop();
    }
    else{
      turnLeft();
      moveStop();
    }
  }
  else{
    moveForward(); 
  }
    distance = readPing();
}}
